# JHipster Lite quick start guide

You can follow this guide to generate your new project with JHipster Lite.

You can use the online version at [https://lite.jhipster.tech](https://lite.jhipster.tech)

Or, you can start JHipster Lite locally. Clone the project and in the `jhipster-lite` folder, just launch: `./mvnw`

Then, you need to fill the different fields, before generating something:

![fill_information](01-fill_information.png)

You can start by initializing your project, adding the Git configuration, the IDE configuration and a simple `package.json` file:

![init](02-init.png)

You generate a Maven project, by adding a Maven wrapper and a default `pom.xml`:

![maven](03-maven.png)

Let's add the Java base and all asserts classes:

![java_base](04-java_base.png)

You need to select the Spring Boot section:

![spring_boot_section](05-spring_boot_section.png)

Now, you can add Spring Boot:

![spring_boot](06-spring_boot.png)

Let's add an application server, using Tomcat:

![spring_boot_mvc](07-spring_boot_mvc.png)

You can add a simple front-end, using Vue 3:

![vue](08-vue.png)

To make the front-end work with the back-end, you need to add the Frontend Maven Plugin:

![frontend-maven-plugin](09-frontend_maven_plugin.png)

Finally, you can download the project:

![download](10-download.png)
